'''
enviroment:
pip install pathos moviepy
'''

import os
from pathos.multiprocessing import ProcessingPool as Pool
from moviepy.editor import AudioFileClip

def convert_to_wav(filename):
    clip = AudioFileClip(filename)
    wav_filename = filename.replace("video/", "audio/").replace(".mp4", ".wav")
    clip.write_audiofile(wav_filename, fps=5000, bitrate="5k")

def main():
    input_directory = "MicroLens-50k_videos/"
    output_directory = "MicroLens-50k_audio/"

    # # Create the output directory if it doesn't exist
    if not os.path.exists(output_directory):
        os.makedirs(output_directory)

    mp4_files = [f for f in os.listdir(input_directory) if f.endswith('.mp4')]
    full_paths = [os.path.join(input_directory, f) for f in mp4_files]

    # Use multiprocessing to convert files
    with Pool(5) as p:  # specify the number of processes here
        p.map(convert_to_wav, full_paths)

if __name__ == "__main__":
    main()
